%% GRK - Grafika Komputerowa (IB) - Lab2
% Funkcja implementujca algorytm Bresenhama rasteryzacji odcinka
% (wersja podstawowa dziaajca dla odcinkw o nachyleniu (0,45] stopni)

function bresenham_line(xp, xk, yp, yk)

%% wyznaczenie wartoci zmiennych pomocniczych
dx = xk - xp;
dy = yk - yp;
p1 = 2 * dy;
p2 = 2 * (dy - dx);

%% sprawdzenie warunku nachylenia odcinka
a = dy/dx;
if (a < 0 || a > 1)
    disp('Bd: nieprawidowe nachylenie odcinka');
	return;
end

%% ustalenie pocztkowej wartoci zmiennej decyzyjnej
d = 2 * dy - dx;

%% ustalenie pozycji pierwszego piksela na punkt pocztkowy odcinka
x = xp;
y = yp;

%% gwna ptla algorytmu wybierajca w kolejnych iteracjach odpowiednie
% piksele w zalenoci od aktualnej wartoci zmiennej decyzyjnej
for i = 1 : dx+1

    % narysowanie piksela w lokalizacji (x,y) 
    rectangle('Position',[x-0.5, y-0.5, 1, 1],'FaceColor','b');
	
    % aktualizacja (x,y) i modyfikacja zmiennej decyzyjnej
    if (d < 0)
        % wybr piksela poniej teoretycznego przebiegu odcinka
        d = d + p1;
        x = x + 1;
    else
        % wybr piksela powyej teoretycznego przebiegu 
        d = d + p2;
        x = x + 1;
        y = y + 1;
    end
end
