%% GRK - Grafika Komputerowa (IB) - Lab2
% Funkcja realizujca algorytm Cohena-Sutherlanda przycinania odcinka
% Opracowa: mgr in. Rafa Jwiak


%% funkcja realizujca algorytm
function [px1, py1, px2, py2] = cohen_sutherland(wx1, wy1, wx2, wy2, xp, yp, xk, yk)

% kodowanie kocw odcinka
kod1 = koduj_koniec(xp, yp, wx1, wy1, wx2, wy2);
kod2 = koduj_koniec(xk, yk, wx1, wy1, wx2, wy2);

% sprawdzanie lokalizacji odcinka
while (1)
    % odcinek cakowicie wewntrz okna widoku
    if (~any(kod1 | kod2))
        px1 = xp;
        px2 = xk;
        py1 = yp;
        py2 = yk;
        % aktualizacja rysunku
        plot([px1 px2], [py1 py2],'g-','LineWidth',3);
        disp('Sytuacja koncowa.');
        return;
    end
    % odcinek cakowicie poza oknem widoku
    if (any(kod1 & kod2))
        px1 = xp;
        px2 = xk;
        py1 = yp;
        py2 = yk;
        % aktualizacja rysunku
        plot([px1 px2], [py1 py2],'r-','LineWidth',3);
        disp('Sytuacja koncowa.');
        return;
    end
    % sytuacja niejednoznaczna - wymaga przycinania  
    % wybrnie koca do przycinania
    if (any(kod1))
        kod = kod1;
    else
        kod = kod2;
    end
 
    % przycinanie przez odpowiedni prost
    if (kod(1) == 1)
        % przycinanie przez krawd grn
        yt = wy2;
        t = (yt-yp) / (yk-yp);
        xt = xp + t*(xk-xp);
    elseif (kod(2) == 1)
        % przycinanie prze krawd doln
        % UZUPENI
    elseif (kod(3) == 1)
        % przycinanie przez krawd praw
        % UZUPENI           
    elseif (kod(4) == 1)
        % przycinanie przez krawd lew
        % UZUPENI
    end
    
    % ustalenie nowych wsporzdnych przycitego koca i aktualizacja kodw
    if (kod == kod1)
        xp = xt;
        yp = yt;
        kod1 = koduj_koniec(xp, yp, wx1, wy1, wx2, wy2);
        % aktualizacja rysunku
        plot(xp, yp, 'LineStyle', 'none', 'Marker', 'o', 'MarkerEdgeColor', 'g', 'MarkerFaceColor', 'g');
        disp('Przycieto odcinek.');
    else
        xk = xt;
        yk = yt;
        kod2 = koduj_koniec(xk, yk, wx1, wy1, wx2, wy2);
        plot(xk, yk, 'LineStyle', 'none', 'Marker', 'o', 'MarkerEdgeColor', 'g', 'MarkerFaceColor', 'g');
        disp('Przycieto odcinek.');
    end
end
end



%% funkcja koduj_koniec przypisuje odpowiedni kod binarny w zalenoci od
% lokalizacji wsprzdnych odcinka wzgldem okna widoku
function kod = koduj_koniec(x, y, wx1, wy1, wx2, wy2)

% kod pocztkowy - odcinek wewntrz widoku okna
kod = [0 0 0 0];

% sprawdzenie czy odcinek wystaje poza lew granic okna
% UZUPENI

% sprawdzenie czy odcinek wystaje poza praw granic okna
% UZUPENI

% sprawdzenie czy odcinek wystaje poza doln granic okna
% UZUPENI

% sprawdzenie czy odcinek wystaje poza grn granic okna
if (y > wy2) 
    kod(1) = 1;
end
    
end

