%% GRK - Grafika Komuterowa (IB) - Lab2
%% funkcja sledzenia - wypenia obszar algorytmem sledzenia

function stan = sledzenie(xs,ys,kk,kw)

% INICALIZACJA
% stan poczatkowy zolwia - zolw skierowany w lewo
% inne mozliwe stany: 1 w lewo, 2 do gory, 3 w prawo, 4 do dolu
stan = 0;
% aktualny punkt
x = xs;
y = ys;
% przygotowanie - dosun zolwia w lewo do sciany konturu
[x,y] = przesun_lewo(x,y,kk);
% zapamitaj wspolrzedne
xw = x;
yw = y;
% obrot zolwia w prawo o 90 stopni
stan = mod(stan + 1,4);

% GLOWNA CZESC ALGORYTMU
while (1)
    % sprawdz czy zolw dotyka lewym bokiem konturu (funkcja pobierz_kolor_lewo)
    % jesli tak
        % zmien kolor punktow na prostej prostopadlej do konturu w aktualnym punkcie (funkcja wypelnij)
        % sprawdz czy zolw dotyka gowa konturu (funkcja pobierz_kolor_przod)
        % jesli tak
            % obroc zolwia w prawo o 90 stopni (stan + 1)
            % krok do przodu o jeden punkt rastra (f. krok)
        % w przeciwnym razie
            % krok do przodu o jeden punkt rastra (f. krok)
    % w przeciwnym razie
        % obroc zolwia w lewo o 90 stopni (stan - 1)
        % krok do przodu o jeden punkt rastra (f. krok)
  
    if (x == xw) && (y == yw) % (warunek przerwania algorytmu)
       break; % przerwij wykonywanie petli glownej
    end
end

end


function k = pobierz_kolor(x,y)
% pobranie koloru piksela 
k = [0 0 0];
h=findobj(findobj(gca,'Type', 'rectangle'),'Position',[x-0.5 y-0.5 1 1]);
if ~isempty(h)
    k = get(h,'FaceColor');
    if (iscell(k))
        k = k{1};
    end
end
end


function [xa,ya] = przesun_lewo(xa,ya,kk)
% przesuniecie w lewo do granicy konturu
k = pobierz_kolor(xa,ya);
while any(k ~= kk)
    k = pobierz_kolor(xa-1,ya);
    if k == [0 0 0]
        xa = xa - 1;
    end   
end  

end


function k = pobierz_kolor_lewo(stan,xa,ya)
% ustalenie lokalizacji do pobrania koloru w zaleznosci od stanu
switch stan
    case 0
        ya = ya - 1;
    case 1
        xa = xa - 1;
    case 2
        ya = ya + 1;
    case 3
        xa = xa + 1;
end   

% pobranie koloru piksela 
k = [0 0 0];
h=findobj(findobj(gca,'Type', 'rectangle'),'Position',[xa-0.5 ya-0.5 1 1]);
if ~isempty(h)
    k = get(h,'FaceColor');
    if (iscell(k))
        k = k{1};
    end
end

end


function status = wypelnij(stan,xa,ya,kk,kw)
% wypelnianie lini
k = pobierz_kolor(xa,ya);
stan = mod(stan + 1,4);
while any(k ~= kk)
    rectangle('Position',[xa-0.5, ya-0.5, 1, 1],'FaceColor',kw); 
    [xa,ya] = krok(stan,xa,ya);
    k = pobierz_kolor(xa,ya);
end  
status = 1;
end


function k = pobierz_kolor_przod(stan,xa,ya)
% ustalenie lokalizacji do pobrania koloru w zaleznosci od stanu
switch stan
    case 0
        xa = xa - 1;
    case 1
        ya = ya + 1;
    case 2
        xa = xa + 1;
    case 3
        ya = ya - 1;
end   

% pobranie koloru piksela 
k = [0 0 0];
h=findobj(findobj(gca,'Type', 'rectangle'),'Position',[xa-0.5 ya-0.5 1 1]);
if ~isempty(h)
    k = get(h,'FaceColor');
    if (iscell(k))
        k = k{1};
    end
end
end

function [xa,ya] = krok(stan,xa,ya)
% ustalenie kroku w zaleznosci od stanu
switch stan
    case 0
        xa = xa - 1;
    case 1
        ya = ya + 1;
    case 2
        xa = xa + 1;
    case 3
        ya = ya - 1;
end   

end

